package com.titan.cruise;

import javax.ejb.CreateException;
import javax.ejb.RemoveException;
import javax.ejb.EntityContext;
import com.titan.ship.*;
import java.util.Collection;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import sequencegenerator.SequenceSessionLocalHome;
import sequencegenerator.SequenceSessionLocal;

public abstract class CruiseBean implements javax.ejb.EntityBean {

    private sequencegenerator.SequenceSessionLocalHome seqHome = null;
    private sequencegenerator.SequenceSessionLocal  seqLocal = null;

    public Integer ejbCreate(String name, ShipLocal ship)  throws CreateException {
	System.out.println("CruiseBean: ejbCreate");
	setName(name);
	int id = seqLocal.getNextNumberInSequence("Cruise");
	System.out.println("CruiseBean ejbCreate name= "+name+"ID = "+id);
	setId(new Integer(id));
	return null;
    }
	
    public void ejbPostCreate(String name, ShipLocal ship) {
	setShip(ship);
    }

    // persistent fields

    public abstract void setId(Integer id);
    public abstract Integer getId();
    public abstract void setName(String name);
    public abstract String getName( );

    public abstract void setShip(ShipLocal ship);
    public abstract ShipLocal getShip( );

    // relationship fields

    public abstract void setReservations(Collection res);
    public abstract Collection getReservations( );

    // standard call back methods
    
    public void setEntityContext(EntityContext ec){
	try {
	    InitialContext cntx = new InitialContext( );
	    SequenceSessionLocalHome  seqHome  = 
		(SequenceSessionLocalHome)cntx.lookup("java:comp/env/ejb/SequenceSessionLocalHome");
	    seqLocal = seqHome.create();
	} catch(Exception e) {
	    throw new javax.ejb.EJBException(e);
	}
    }

    public void unsetEntityContext(){}
    public void ejbLoad(){}
    public void ejbStore(){}
    public void ejbActivate(){}
    public void ejbPassivate(){}
    public void ejbRemove() throws RemoveException  {}

}
