/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * Initial developer(s): ____________________________________.
 * Contributor(s): 
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */


package org.objectweb.jonas.common;

import javax.naming.NamingEnumeration;
import javax.naming.NameClassPair;
import javax.naming.Context;
import javax.naming.NamingException;
import org.objectweb.util.monolog.api.Logger;

/**
 * Used to print out a Naming context content
 */
public class ContextDump {

    public static void print(String header, Context ctx, Logger logger, int logLevel) {
	logger.log(logLevel, header);
	logger.log(logLevel, "=================================");
	String aName = null;
	String aValue = null;
	try {
	    for(NamingEnumeration pNames = ctx.list("") ; pNames.hasMoreElements() ; ) {
		aName = ((NameClassPair)pNames.nextElement()).getName();
		aValue = (String)ctx.lookup(aName);
		if (aValue != null)
		    logger.log(logLevel, aName + " = " + aValue);
	    }
	} catch(NamingException ne) {
            logger.log(logLevel, "Failed to dump contex: " + ne.toString());
	}
	logger.log(logLevel, "=================================");
    }
}
