#!/bin/sh
# ---------------------------------------------------------------------------
# JOnAS: Java(TM) Open Application Server
# Copyright (C) 1999 Bull S.A.
# Contact: jonas-team@objectweb.org
# 
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or any later version.
# 
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
# USA
#
# ---------------------------------------------------------------------------
# $Id$
# ---------------------------------------------------------------------------

#
# Usage:	junit [ dir-name [ suite-name [ test-name ] ] ]
#
# This script allows to run the jonas-test all the tests or a sub-set of the tests:
# - the tests of the given directory
# - the tests of the given suite of the given directory
# - only the given test of the given suite of the given directory
#


# update classpath for junit tests
# update the following lines depending on your own environment
for CLS in \
/server/products/junit/junit3.7/junit.jar \
$PROJ_BASE/objectweb/jonas_tests/conformance/classes/$OBJECTWEB_ORB \
$PROJ_BASE/objectweb/jonas_tests/stress/classes/$OBJECTWEB_ORB
do
    echo $CLASSPATH | grep $CLS >/dev/null || CLASSPATH=$CLASSPATH:$CLS
done



PACK=org.objectweb.jonas.jtests.clients
DIR=suite
SUITE=C_suite
TEST=

if [ $# -gt 0 ]
then
	DIR=$1
	SUITE=C_$DIR
	if [ "$DIR" = "manac" ]
	then
	    PACK=org.objectweb.jonas.stests
	    jonas admin -n EJB -tt 8
	fi
	if [ "$DIR" = "manyops" ]
	then
	    PACK=org.objectweb.jonas.stests
	fi
	shift
fi
if [ $# -gt 0 ]
then
	SUITE=$1
	shift
fi
if [ $# -gt 0 ]
then
	PREFIX=`echo "$SUITE" | cut -b 1-2`
	if [ "$PREFIX" != "F_" ]
	then
		echo "ERROR: a test-name may be specified only for a final suite (F_xxx)"
		exit 2
	fi
	TEST="-n $1"
	shift
fi


# important to be seen in jclient script
export CLASSPATH


echo "Running junit test : $DIR/$SUITE $TEST"
jclient $PACK.$DIR.$SUITE $TEST
