
package applis.ejb.perfs;

import java.rmi.RemoteException;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.RemoveException;
import javax.ejb.CreateException;

import org.objectweb.jonas.common.Trace;


public abstract class Perfs2Bean implements EntityBean {
 
    static private int trace = Trace.DB_1;

    protected EntityContext entityContext;

    public abstract String getValue();
    public abstract void setValue(String v);
    public abstract int getCode();
    public abstract void setCode(int v);

    public PerfsBeanPK ejbCreate(int i, String s) throws CreateException, RemoteException {
	setCode(i);
	setValue(s);
	// In CMP, should return null.
	return null;
    }

    public void ejbPostCreate(int i, String s) throws CreateException, RemoteException {
    }

    public void ejbActivate() throws RemoteException {
    }

    public void ejbPassivate() throws RemoteException {
    }

    public void ejbLoad() throws RemoteException {
    }

    public void ejbStore() throws RemoteException {
    }
  
    public void ejbRemove() throws RemoveException{
    }

    public void setEntityContext(EntityContext ctx) {
	Trace.outln(trace, "Perfs2Bean.setEntityContext()");
	entityContext  = ctx;
    }

    public void unsetEntityContext() {
    }

    public String read() throws RemoteException {
	Trace.outln(trace, "Perfs2Bean.read() -> " + getValue());
	return getValue();
    }

    public void write(String value) throws RemoteException {
	Trace.outln(trace, "Perfs2Bean.write(String "+value+")");
	setValue(new String(value));
    }

    public String txread() throws RemoteException {
	Trace.outln(trace, "Perfs2Bean.txread() -> " + getValue());
	return getValue();
    }

    public void txwrite(String value) throws RemoteException {
	Trace.outln(trace, "Perfs2Bean.txwrite(String "+value+")");
	setValue(new String(value));
    }

} 

